# SourcePath: gcc-gplv3-6.4.0/20180309
Summary: GCC libraries and headers for glibc
Name: sony-target-dev-gcc-gplv3-libs
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-gcc-libs
Version: 6.4.0
Release: 14000001
License: special exception
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.gnu.org/software/gcc
Source0: gcc-%{version}.tar.bz2

# Patch to build Sony CE Linux distro.
Patch001: 0001-gcc-4.3.1-ARCH_FLAGS_FOR_TARGET.patch 
Patch002: 0010-gcc-poison-system-directories.patch 
Patch003: 0011-gcc-poison-dir-extend.patch
Patch004: 0022-gcc-Fix-argument-list-too-long-error.patch
Patch005: 0032-gcc-4.8-won-t-build-with-disable-dependency-tracking.patch
Patch006: 0042-gcc-libcpp-support-ffile-prefix-map-old-new.patch
Patch007: 0044-gcc-final.c-fdebug-prefix-map-support-to-remap-sourc.patch
Patch008: 0046-Link-libgcc-using-LDFLAGS-not-just-SHLIB_LDFLAGS.patch
Patch009: CVE-2016-6131.patch
#Patch010: ubsan-fix-check-empty-string.patch
Patch011: autoconf-version-change.patch
Patch012: asan-test-hang-issue-fix.patch

Patch101: gcc-4.5.1-arm-ARMCC-build-break-fix-for-cpp.patch
Patch102: gcc-4.5.1-arm-sony-multidialect-support.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix: %{sony_target_dir}

%description
This is the GNU C compiler, a fairly portable optimizing compiler which
supports multiple languages.  This package includes support for C.  It also
includes the GNU C preprocessor.

%package -n %{pkgname}
Summary: GCC libraries and headers for glibc
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
This is the GNU C compiler, a fairly portable optimizing compiler which
supports multiple languages.  This package includes support for C.  It also
includes the GNU C preprocessor.

%prep
%setup -q -n gcc-%{version}

%patch001 -p1
%patch002 -p1
%patch003 -p1
%patch004 -p1
%patch005 -p1
%patch006 -p1
%patch007 -p1
%patch008 -p1
%patch009 -p1
#%patch010 -p1
%patch011 -p1
%patch012 -p1
%patch101 -p1
%patch102 -p1

%build
%if %{sony_host_arch} == "x86_64"
export LDFLAGS="-L%{sony_host_lib64_dir}"
%endif

%sony_cross_dev_setup

( cd gcc && autoconf ) &&
( cd libstdc++-v3 && autoconf && aclocal ) &&
#( cd libmudflap && autoconf && aclocal ) &&	#As Libmudflap is removed from gcc-4.9.3 source, disabling in spec file
( cd libssp && autoconf && aclocal ) &&
( cd libgomp && autoconf && aclocal ) &&
( cd gcc && autoheader ) &&
####################################################
#  libgcc, libstdc++-v3, libmudflap, libssp, libgomp
####################################################
%sony_cross_dev_configure \
	--prefix=%{sony_target_dev_prefix} \
	--enable-languages=c,c++ \
%if "%{sony_target_cpu_id}" != "%%%{sony_target_cpu_id}"
%if "%{sony_target_cpu}" != "arm"
	--with-cpu=%{sony_target_cpu_id} \
%endif
%endif
%if "%{sony_target_arch_id}" != "%%%{sony_target_arch_id}"
	--with-arch=%{sony_target_arch_id} \
%endif
%if "%{sony_target_tune_id}" != "%%%{sony_target_tune_id}"
	--with-tune=%{sony_target_tune_id} \
%endif
%if "%{sony_target_fpu}" == "no"
	--with-float=soft \
%endif
%if "%{sony_target_altivec}" == "yes"
	--enable-altivec \
%endif
	--with-sysroot=%{sony_cross_dev_dir}/../target/%{sony_target_dialect} \
	--with-gmp=%{sony_host_dir} \
	--with-mpfr=%{sony_host_dir} \
	--with-mpc=%{sony_host_dir} \
	'--with-specs=%{funwind-tables|fno-unwind-tables|mabi=*|ffreestanding|nostdlib:;:-funwind-tables}' \
	--enable-__cxa_atexit \
	--disable-multilib \
        --disable-libitm \
	--enable-threads=posix \
	--enable-shared \
	--disable-libcc1 \
	--with-arch="armv8-a+crypto" \
	--with-gxx-include-dir=%{sony_target_dev_include_dir}/c++/%{version} &&
	#
	#  Build all lib.
	#
make "FLAGS_FOR_TARGET= -O2 %{sony_target_machine_option}" "CFLAGS_FOR_TARGET= -O2 %{sony_target_machine_option}" "CXXFLAGS_FOR_TARGET= -O2 %{sony_target_machine_option}" all-target-libgcc \
      all-target-libstdc++-v3 \
      all-target-libsanitizer \
      all-target-libvtv \
      all-target-libatomic \
      all-target-libssp \
      all-target-libgomp \
      all-target-libquadmath

      #all-target-libmudflap	#As Libmudflap is removed from gcc-4.9.3 source, disabling in spec file
%install
%sony_cross_dev_setup

#rm -rf %{buildroot}

cd %{sony_objdir} && make \
   DESTDIR=%{buildroot}%{sony_target_dir} install

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}/share
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}/libexec
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}

%define toollibdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
%define libdir %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

mv %{libdir}/../%{sony_target_config}/lib64/* %{libdir}
# remove libiberty.a which will conflict with binutils.
%if %{sony_host_arch} == "x86_64"
rm -rf %{buildroot}%{sony_target_dir}/%{sony_target_dev_prefix}/lib64
%endif

rm -rf %{libdir}/libiberty.a
rm -rf %{libdir}/../%{sony_target_config}

# remove libstdc++.so.6.0.22-gdb.py due to license issue
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libstdc++.so.6.0.22-gdb.py

for l in `ls %{libdir}/*.la`; do
  echo "$(cat $l | sed -e 's,%{sony_target_config}/,,')" > $l
done

mkdir -p %{libdir}
mkdir -p %{toollibdir}

mv %{libdir}/*.a %{toollibdir}
mv %{libdir}/gcc %{toollibdir}

# link crt*.o, *.a, include and include-fixed to /usr/lib dir on target.
for l in `ls -d %{toollibdir}/gcc/%{sony_target_config}/%{version}/{*.a,crt*o,include,include-fixed}`; do
  ln -s gcc/%{sony_target_config}/%{version}/$(basename $l) \
        %{libdir}/$(basename $l)
done

%demangle_libtool

# for CE 6.x

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
        ln -s ../..%{sony_target_devtool_lib_dir}/$l \
                %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
done

#%clean
#rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)
%{sony_target_dir}%{sony_target_dev_include_dir}/*
%{sony_target_dir}%{sony_target_dev_lib_dir}/*
%{sony_target_dir}%{sony_target_devtool_lib_dir}/*

%changelog
* Fri Mar 09 2018 Sony Corporation
- Updated version to 6.4.0.

* Wed Sep 13 2017 Sony Corporation
- Disabled libcc1 plugin support for build2 release

* Fri Jun 16 2017 Sony Corporation
- Updated version to 6.3.0.

* Thu Jan 12 2017 Sony Corporation
- Updated version to 4.9.3.

* Mon Apr 18 2016 Sony Corporation
- Added support for armhf

* Thu Feb 28 2013 Sony Corporation
- Updated version to 4.7.3.

* Fri Jul 13 2012 Sony Corporation
- Added fstrict-volatile-bitfields option support patches

* Mon Jan 09 2012 Sony Corporation
- Added gcc ICE fix patches.

* Mon Dec 26 2011 Sony Corporation
- Added glibc build break fix patch for armv7a.

* Tue Nov 15 2011 Sony Corporation
- Added NEON support patches.

* Mon Oct 03 2011 Sony Corporation
- update gcc to make -funwind-tables default.

* Thu Apr 21 2011 Sony Corporation
- Fix override of SUBTARGET_CPU_DEFAULT.

* Fri Mar 11 2011 Sony Corporation
- GCC-4.5.1 information table patch merging.
- glibc softfp invalid exception fix patch is added.

* Thu Mar 10 2011 Sony Corporation
- ARMCC patch refresh for gcc-4.5.1

* Tue Mar 08 2011 Sony Corporation
- libmudflap pass41-frag fix patch is added.
- libmudflap regression fix patch is added.

* Fri Jan 21 2011 Sony Corporation
- Cleanup ARM -mcpu -march handling patch is added.
- New costing infrastructure on ARM patch is added for dependency.

* Wed Jan 19 2011 Sony Corporation
- a patch to enable sibling calls for Thumb2 is added.

* Wed Jan 12 2011 Sony Corporation
- added Ignore_artificial_typedefs fix patch

* Wed Aug 25 2010 Sony Corporation
- Initial build.
